package org.llvm.adt.aliases;

import java.util.Arrays;
import org.clank.support.Converted;
import org.clank.support.Destructors.ClassWithDestructor;
import org.clank.support.Native;
import org.clank.support.NativePointer;
import org.clank.support.*;
import org.clank.support.aliases.*;
import static org.clank.support.NativeType.*;
import static org.clank.support.Native.*;

/**
 * SmallVector for ${TYPE}
 */
//<editor-fold defaultstate="collapsed" desc="template">
@Converted(kind = Converted.Kind.DUMMY, source = "${SPUTNIK}/modules/org.llvm.adtsupport/src/org/llvm/adt/aliases/templates/SmallVector.tpl")
//</editor-fold>
public class ${FILE_NAME}${CLASS_SUFFIX} extends ${SMALL_VECTOR_IMPL} implements NativeCloneable<${FILE_NAME}${CLASS_SUFFIX}> {
  
  public ${FILE_NAME}(long capacity) {
    super(capacity, (${TYPE}) ${DEFAULT_VALUE});
  }

  public ${FILE_NAME}(long capacity, ${TYPE} defaultValue) {
    super(capacity, defaultValue);
  }
  
  public ${FILE_NAME}(long capacity, long initialSize, ${TYPE} defaultValue) {
    super(capacity, initialSize, defaultValue);
  }    

  public ${FILE_NAME}(long capacity, long initialSize, ${TYPE} value, ${TYPE} defaultValue) {
    super(capacity, initialSize, value, defaultValue);
  }    

  public ${FILE_NAME}(long capacity, ${TYPE} array[], long length) {
    super(array, length, (${TYPE}) ${DEFAULT_VALUE});
  }

  public ${FILE_NAME}(long capacity, ${TYPE} array[], long length, ${TYPE} defaultValue) {
    super(array, length, defaultValue);
  }

  public ${FILE_NAME}(long capacity, ${ITERATOR_TYPE} iter, long length) {
    super(capacity, iter, length, (${TYPE}) ${DEFAULT_VALUE});
  }

  public ${FILE_NAME}(long capacity, ${ITERATOR_TYPE} iter, long length, ${TYPE} defaultValue) {
    super(capacity, iter, length, defaultValue);
  }

  public ${FILE_NAME}(long capacity, ${ITERATOR_TYPE} begin, ${ITERATOR_TYPE} end) {
    super(capacity, begin, end, (${TYPE}) ${DEFAULT_VALUE});
  }

  public ${FILE_NAME}(long capacity, ${ITERATOR_TYPE} begin, ${ITERATOR_TYPE} end, ${TYPE} defaultValue) {
    super(capacity, begin, end, defaultValue);
  }

  public ${FILE_NAME}(${FILE_NAME}${CLASS_SUFFIX} other) {
    super(other);
  }

  @Override
  public ${FILE_NAME}${CLASS_SUFFIX} clone() {
    return new ${FILE_NAME}${CLASS_SUFFIX}(this);
  }
}
